function SngmbhSerialcodesValidator(_myAjaxVar) {
	let _self = this;
	let PREMIUM = null;
	var $ = jQuery;
	let myAjax = typeof _myAjaxVar === "undefined" ? null : _myAjaxVar;
	if (myAjax === null) return;
	var _prefix = myAjax.divPrefix;
	var _spinnerElemId = _prefix + 'spinner';
	var DATA = {
        /*action: '',*/
        nonce: myAjax.nonce
    };

	var FATAL_ERROR = false;
    var LAYOUT = null;

	var DIV_ID = myAjax.divId;
	var DIV_MAIN = null;
	var DATEN_URL = myAjax.url;
	var PARAS = {};
	var CODE_ELEMENT;
	var BUTTON_ELEMENT;
	var ELEM_OUTPUT;

	function macheAjax(url, funcSuccess, funcError, doNotShowSpinner){
		let _spinnerElem;
		if (!doNotShowSpinner) {
			_spinnerElem = document.getElementById(_spinnerElemId);
			if (!_spinnerElem) {
				_spinnerElem = document.createElement('div');
				_spinnerElem.id = _spinnerElemId;
				//_spinnerElem.innerHTML = "<center>...loading...</center>";
				_spinnerElem.innerHTML = _getSpinnerHTML();
				_spinnerElem.style.zIndex = "1000";
				//_spinnerElem.style.backgroundColor = "#2e74b5";
				//_spinnerElem.style.color = "white";
				//_spinnerElem.style.borderRadius = "4px";
				//_spinnerElem.style.boxShadow = "0px 0px 10px #333333";
				_spinnerElem.style.verticalAlign = "center";
				_spinnerElem.style.height = "30px";
				_spinnerElem.style.width = "100px";
				_spinnerElem.style.display = "none";
				_spinnerElem.style.position = "absolute";
				_spinnerElem.style.top = "0";
				_spinnerElem.style.left = "0";
				_spinnerElem.style.marginTop = "30%";
				_spinnerElem.style.marginLeft = "50%";
				document.body.appendChild(_spinnerElem);
			}
			_spinnerElem.style.display = "block";
		}
		var xhttp = new XMLHttpRequest();
		xhttp.onreadystatechange = function() {
		  if (this.readyState === 4) {
		  	if (this.status === 200) {
		  		if (this.responseText === '505') {
		  			if (funcError) funcError(this.responseText);
		  			else alert("fehler 505");
		  		} else {
		  			if (funcSuccess) funcSuccess(this.responseText);
				}
			} else if (this.status === 404) {
				if (funcError) funcError(this.responseText, this.status);
			}
			if (_spinnerElem) _spinnerElem.style.display = "none";
		  }
		};
		xhttp.open("GET", url, true);
		xhttp.send(url);
		return xhttp;
	};

	function basics_ermittelJSPath(filename) {
		let basePath = null;
	  	var scripts = document.getElementsByTagName('script');
	    for (var i = scripts.length - 1; i >= 0; --i) {
	      var src = scripts[i].src.split('?')[0];
	      var l = src.length;
	      var length = filename.length;
	      if (src.substr(l - length) === filename) {
	        basePath = src.substr(0, l - length);
	      }
	    }
	    return basePath;
	}
	function _server_result_getError(error) {
		var erg = error.trim().match(/#([0-9|a-z|A-Z]+)/);
		let errorCode = 0;
	    if (erg) errorCode = trim(erg[1]);
	  	return parseInt(errorCode, 10);
	}
	function basics_ermittelURLParameter() {
		var parawerte = {};
	    var teile;
	    if (window.location.search !== "") {
	        teile = window.location.search.substring(1).split("&");
	        for (var a=0;a<teile.length;a++)
	        {
	            var pos = teile[a].indexOf("=");
	            if (pos < 0) {
	                parawerte[teile[a]] = true;
	            } else {
	                var key = teile[a].substr(0,pos);
	                parawerte[key] = decodeURIComponent(teile[a].substr(pos+1));
	            }
	        }
	    }
	    return parawerte;
	}

	class Layout {
		renderEingabeMaske() {
			_renderEingabeMaske();
		}
		renderInputMaske(input_id,btn_id) {
			return '<div class="sngmbh_container">'
			+ '<div class="sngmbh_input-group sngmbh_mb-3">'
			+ '<input required type="text" class="sngmbh_form-control sngmbh_mb-2" data-input="'+input_id+'" placeholder="XXYYYZZ">'
			+ '<div class="sngmbh_input-group-append"><button type="submit" data-btn="'+btn_id+'" class="sngmbh_btn sngmbh_btn-primary sngmbh_mb-2">Check</button></div>'
			+ '</div>'
			+ '</div>';
		}
		showCheckResult(obj) {
			function __displayMessage(text) {
				ELEM_OUTPUT.innerHTML = text;
				BUTTON_ELEMENT.disabled = false;
				CODE_ELEMENT.disabled = false;
			}

			if (obj.success === false) {
				//let error_code = _server_result_getError(obj.error.msg);
				__displayMessage('<center><span style="color:red;font-weight:bold;">'+obj.data.msg+'</span></center>');
				//return alert(obj.data.msg);
				return;
			}
			let valid = obj.data.valid;
			let default_msgs = {'msgCheck0':'Code not found',
			'msgCheck1':'Code confirmed',
			'msgCheck2':'Please contact support for further investigation',
			'msgCheck3':'Code expired',
			'msgCheck4':'Is registered to a user',
			'msgCheck5':'Code is already used'};
			let msgs = default_msgs;
			if (typeof myAjax._messages !== "undefined") msgs = myAjax._messages;

			let text = "";

			CODE_ELEMENT.classList.remove("sngmbh_is-valid");
			CODE_ELEMENT.classList.remove("sngmbh_is-invalid");
			if (valid === 1) {
				CODE_ELEMENT.classList.add("sngmbh_is-valid");
				text = '<center><span style="color:green;font-weight:bold;">'+(msgs.msgCheck1.trim() !== "" ? msgs.msgCheck1 : default_msgs.msgCheck1)+'</span></center>';
			} else if (valid === 2) {
				CODE_ELEMENT.classList.add("sngmbh_is-valid");
				text = '<center><span style="color:red;font-weight:bold;">'+(msgs.msgCheck2.trim() !== "" ? msgs.msgCheck2 : default_msgs.msgCheck2)+'</span></center>';
			} else if (valid === 3) {
				CODE_ELEMENT.classList.add("sngmbh_is-valid");
				text = '<center><span style="color:red;font-weight:bold;">'+(msgs.msgCheck3.trim() !== "" ? msgs.msgCheck3 : default_msgs.msgCheck3)+'</span></center>';
			} else if (valid === 4) {
				CODE_ELEMENT.classList.add("sngmbh_is-valid");
				text = '<center><span style="color:red;font-weight:bold;">'+(msgs.msgCheck4.trim() !== "" ? msgs.msgCheck4 : default_msgs.msgCheck4)+'</span></center>';
			} else if (valid === 5) {
				CODE_ELEMENT.classList.add("sngmbh_is-valid");
				text = '<center><span style="color:red;font-weight:bold;">'+(msgs.msgCheck5.trim() !== "" ? msgs.msgCheck5 : default_msgs.msgCheck5)+'</span></center>';
			} else {
				CODE_ELEMENT.classList.add("sngmbh_is-invalid");
				text = '<center><span style="color:red;font-weight:bold;">'+(msgs.msgCheck0.trim() !== "" ? msgs.msgCheck0 : default_msgs.msgCheck0)+'</span></center>';
			}
			__displayMessage(text);
		}
	}

	function _renderEingabeMaske() {
		let btn_id = _prefix + 'btn';
		let input_id = _prefix + 'code';
		DIV_MAIN.innerHTML = '';

		let elem = document.createElement("div");
		elem.className = "sngmbh_container";
		elem.innerHTML = LAYOUT.renderInputMaske(input_id, btn_id);

		ELEM_OUTPUT = document.createElement("div");
		elem.appendChild(ELEM_OUTPUT);
		DIV_MAIN.appendChild(elem);

		if (typeof PARAS.code !== "undefined") {
			document.querySelector('[data-input="'+input_id+'"]').value = encodeURIComponent(PARAS.code.trim());
		}

		CODE_ELEMENT = document.querySelector('[data-input="'+input_id+'"]');
		CODE_ELEMENT.onchange = function() {
			ELEM_OUTPUT.innerHTML = "";
			CODE_ELEMENT.classList.remove("is-valid");
			CODE_ELEMENT.classList.remove("is-invalid");
		}
		CODE_ELEMENT.onkeyup = function() {
			ELEM_OUTPUT.innerHTML = "";
			CODE_ELEMENT.classList.remove("is-valid");
			CODE_ELEMENT.classList.remove("is-invalid");
		}

		BUTTON_ELEMENT = document.querySelector('[data-btn="'+btn_id+'"]');
		BUTTON_ELEMENT.onclick = function() {
			let code = CODE_ELEMENT.value.trim();
			if (code === "") {
				CODE_ELEMENT.select();
				return;
			}

			BUTTON_ELEMENT.disabled = true;
			CODE_ELEMENT.disabled = true;
			ELEM_OUTPUT.innerHTML = '<center>'+_getSpinnerHTML()+'</center>';

			let url = DATEN_URL+'?action='+myAjax._action+'&a=checkCode&data[code]='+encodeURIComponent(code)+'&t='+new Date().getTime();
			macheAjax(url, function(responseText) {
				let obj = JSON.parse(responseText);
				LAYOUT.showCheckResult(obj);
			}, null, true);
		}
	}

	function checkIfCssRuleExists(identifier) {
		let styles = document.styleSheets;
		for(var a=0;a<styles.length;a++) {
			try {
				let rules = styles[a].cssRules;
				for(var b=0;b<rules.length;b++){
					if (rules[b].cssText.match(identifier)) return true;
				};
			} catch(e) {}
		}
		return false;
	}
	function addStyleCode(content) {
		let c = document.createElement('style');
		c.innerHTML = content;
		document.getElementsByTagName("head")[0].appendChild(c);
	}
	function addStyleTag(url, id, onloadfkt, attrListe, loadLatest) {
	  var script  = document.createElement('link');
	  script.type = 'text/css';
	  script.rel = "stylesheet";
	  let myId = id;
	  if (!myId) myId = url;
		if (document.getElementById(id) && document.getElementById(id).src === url) {
			onloadfkt && onloadfkt();
			return; // prevent re-adding the same tag
		}
	  script.id = id;
	  if (attrListe) for(var attr in attrListe) script.setAttribute(attr, attrListe[attr]);
	  script.href = url;
	  if (loadLatest) script.href += '?t='+new Date().getTime();
	  if (typeof onloadfkt !== "undefined") script.onload = onloadfkt;
	  document.getElementsByTagName("head")[0].appendChild(script);
	}

	function addScriptTag(url, id, onloadfkt, attrListe, loadLatest) {
	  	var head    = document.getElementsByTagName("head")[0];
	  	var script  = document.createElement('script');
	  	script.type = 'text/javascript';
	  	let myId = id;
	  	if (!myId) myId = url;
		if (document.getElementById(id) && document.getElementById(id).src === url) {
			onloadfkt && onloadfkt();
			return; // prevent re-adding the same tag
		}
	  script.id = id;
	  if (attrListe) for(var attr in attrListe) script.setAttribute(attr, attrListe[attr]);
	  script.src = url;
	  if (loadLatest) script.src += '?t='+new Date().getTime();
	  if (typeof onloadfkt !== "undefined") script.onload = onloadfkt;
	  head.appendChild(script);
	}

	function getLabelPremiumOnly() {
		return "[PREMIUM ONLY]";
	}

	function _getSpinnerHTML() {
		return '<span class="lds-dual-ring"></span>';
	}

	function isPremium() {
		return myAjax._isPremium == "1" || myAjax._isPremium === true;
	}

	function getHelperFunktions() {
		return {
			_getSpinnerHTML:_getSpinnerHTML,
			_macheAjax:macheAjax,
			_basics_ermittelJSPath:basics_ermittelJSPath,
			_basics_ermittelURLParameter:basics_ermittelURLParameter,
			_renderEingabeMaske:_renderEingabeMaske,
			_addScriptTag:addScriptTag,
			_addStyleCode:addStyleCode,
			_checkIfCssRuleExists:checkIfCssRuleExists,
			_getCODE_ELEMENT:function(){return CODE_ELEMENT;},
			_getELEM_OUTPUT:function() {return ELEM_OUTPUT;},
			_getBUTTON_ELEMENT:function(){return BUTTON_ELEMENT;},
			_getBasicSelf:function() { return _self;},
			_getLAYOUT:function(){ return LAYOUT;},
			_getDIV_MAIN:function(){ return DIV_MAIN;}
		};
	}

	function init() {
		PARAS = basics_ermittelURLParameter();
		if (!checkIfCssRuleExists('lds-dual-ring')) addStyleCode('.lds-dual-ring {display:inline-block;width:64px;height:64px;}.lds-dual-ring:after {content:" ";display:block;width:46px;height:46px;margin:1px;border-radius:50%;border:5px solid #fff;border-color:#2e74b5 transparent #2e74b5 transparent;animation:lds-dual-ring 0.6s linear infinite;}@keyframes lds-dual-ring {0% {transform: rotate(0deg);}100% {transform: rotate(360deg);}');
		addStyleTag(myAjax._plugin_home_url+'/css/styles.css');
		//addStyleTag('https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css');
		//addStyleTag('https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.css');
		//addScriptTag('https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js');

		LAYOUT = new Layout();

		if (DIV_MAIN == null) {
			DIV_MAIN = document.getElementById(DIV_ID);
			if (DIV_MAIN == null) {
				DIV_MAIN = document.createElement('div');
				document.getElementsByTagName('body')[0].appendChild(DIV_MAIN);
			}
		}

		function _init() {
			LAYOUT.renderEingabeMaske();
			//_renderEingabeMaske();
		}

    	if (isPremium() && myAjax._premJS !== "") {
			if (window.SngmbhSerialcodesValidatorPremium) {
				PREMIUM = new SngmbhSerialcodesValidatorPremium(myAjax, getHelperFunktions());
				_init();
			}
    	} else {
			_init();
    	}
	}

	init();
}
Ajax_sngmbhSerialcodesValidator && SngmbhSerialcodesValidator(Ajax_sngmbhSerialcodesValidator);